<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) ReloadCMS Development Team                                 //
//   http://reloadcms.com                                                     //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////

if (!empty($_POST['backupit'])) {
	if(!empty($_POST['gzip'])) $suffix = '.gz';
	else $suffix = '';
    $bkupfilename = RCMS_ROOT_PATH . 'backups/backup_'.date('d.m.Y_H-i-s').'.tar' . $suffix;
    $backup = new tar();
    $backup->isGzipped = !empty($_POST['gzip']);
    $backup->filename = $bkupfilename;
    $path = getcwd();
    chdir(RCMS_ROOT_PATH);
    $backup->addDirectory('config', true);
    $backup->addDirectory('content', true);
    chdir($path);
    $backup->saveTar();
    rcms_showAdminMessage(__('Backup complete') . ' (' . basename($bkupfilename) . ')');
}
if(!empty($_POST['delete'])) {
	$result = '';
	foreach ($_POST['delete'] as $backup_entry => $cond){
		if(!empty($cond)) {
			if(rcms_delete_files(RCMS_ROOT_PATH . 'backups/'.$backup_entry)) {
				$result .= __('File removed') . ': ' . $backup_entry . '<br/>';
			} else {
				$result .= __('Error occurred') . ': ' . $backup_entry . '<br/>';
			}
		}
	}
	if(!empty($result)) rcms_showAdminMessage($result);
}
if (!empty($_POST['browse_archive']) AND empty($_POST['delete']))	 {
	if(!empty($_POST['restore'])){
	$restorefilename = RCMS_ROOT_PATH . 'backups/'.$_POST['restore'];
	$path = getcwd();
	rcms_delete_files(RCMS_ROOT_PATH .'config',true);
	rcms_delete_files(RCMS_ROOT_PATH .'content',true);
	rcms_loadAdminLib('unpack');
	if (restore($restorefilename)) echo __('Restoring done').'<br/>';
	else echo __('Restore data').': '.__('Error occurred');
	}
}

// Interface generation
$frm =new InputForm ('', 'post', __('Backup data'));
$frm->addbreak( __('Backup data'));
$frm->hidden('backupit', '1');
$frm->addrow(__('To backup all your data from directories "config" and "content" press "Create backup" button. Speed of backup creation depends on size of your site. In order to be more secure we do not provide any backups management from there. You must download or delete backups using FTP or another way to reach /backups/ folder, because HTTP access for it was forbidden.'));
$frm->addrow(__('Pack file with gzip (uncheck if you experience problems)'), $frm->checkbox('gzip', '1', '', true));
$frm->show();
$frm =new InputForm ('', 'post', __('Submit'));
$frm->addbreak( __('Restore data'));
$frm->hidden('browse_archive', '1');
$backups='';
$backups = rcms_scandir(RCMS_ROOT_PATH . 'backups');
	foreach ($backups as $backup_entry){
		if(preg_match("/^((.*?)-(.*?))\.tar(|.gz)$/i", $backup_entry, $matches)){
			$frm->addrow($frm->radio_button('restore', array($backup_entry => $backup_entry), '-1').'&nbsp;&nbsp;['.__('Size of file').'&nbsp;'.filesize(RCMS_ROOT_PATH . 'backups'.'/'.$backup_entry). __(' bytes in size').']&nbsp;&nbsp;', $frm->checkbox('delete[' . $backup_entry. ']', 'true', __('Delete')));
		}
	}
$frm->addrow(__('To restore all your data, select archive and press "Submit" button. Your directory "config" and "content" may be permanently overwritten'));
$frm->show();
?>
